var channelId, channelName, channelUrl, subscriptionsProcessing = false;

window.addEventListener('DOMContentLoaded',()=>{
    //var prms = new URLSearchParams(location.hash.substr(1));
    channelId = location.hash.substr(1);
    pushHistory(channelId,'channel',channelId);
    pushToAllHistory(channelId,'channel');

    var cachedData = itemCache('channels', channelId, 'get');
    if(cachedData) {
        displayChannel(cachedData);
    } else {
        requestItem(
            'channels',
            channelId,
            '',
            (r)=>{
                itemCache('channels', channelId, 'update', r);
                displayChannel(r);
            },  
            null,
            true,
            true
        );
    }

    subscriptionsCheck(channelId, (c)=>{
        var tn = 'subscribe-action';
        if(c){tn = 'un' + tn}
        eid('channel-subscribe').textContent = i18n(tn);
    });
});


function displayChannel(rqResp){
    console.log('display channel.');
    eid('load').classList.add('hidden');
    eid('main').classList.remove('hidden');
    disableControls = false;

    var channelPfp = imgChoose(rqResp.authorThumbnails,'width',100);

    eid('channel-banner').src = imgChoose(rqResp.authorBanners,'width',1000) || '/img/nochannelbanner.png';
    eid('channel-picture').src = channelPfp || '/img/nouserimage-colored.png';
    eid('channel-name').textContent = rqResp.author;
    eid('channel-banner-name').textContent = rqResp.author;
    eid('channel-subcount').textContent = i18n('subscriber-shortened-count', rqResp.subCount, {count: commaSeparateNumber(rqResp.subCount)});
    //eid('channel-subcount').textContent = commaSeparateNumber(rqResp.subCount);
    eid('channel-shortinfo').textContent = i18n(
        'channel-view-join-data', rqResp.totalViews, {
            viewCount: commaSeparateNumber(rqResp.totalViews),
            joinDate: unixdateformat(rqResp.joined)
        }
    );
    //eid('channel-viewcount').textContent = commaSeparateNumber(rqResp.totalViews);
    //eid('channel-joined').textContent = unixdateformat(rqResp.joined);
    eid('channel-description').innerHTML = rqResp.descriptionHtml;

    subscriptionsUpdateMdata(
        rqResp.authorId,
        rqResp.author,
        channelPfp
    );

    channelName = rqResp.author;
    pushHistory(channelId,'channel',channelName);
    //pushToAllHistory(channelId,'channel',channelName);
    mdataStoreSet(
        channelId,
        {
            name: rqResp.author,
            type: 'channel',
            image: channelPfp
        }
    )

    channelUrl = rqResp.authorUrl;


    eid('channel-options').children[0].focus();
    updatenavbar();
}

function selectItem() {
    switch(actEl().dataset.action) {
        case 'videos': goToSearchScreen('channel',channelId,channelName); break;
        case 'playlist': goToSearchScreen('channelPlaylists',channelId,channelName); break;
        case 'sub': 
            if(!subscriptionsProcessing) {
                subscriptionsProcessing = true;
                subscriptionsCheck(channelId, (s)=>{
                    var dfn = ()=>{
                        subscriptionsProcessing = false;
                        var u = '';
                        if(!s){u='un'}
                        eid('channel-subscribe').textContent = i18n(`${u}subscribe-action`);
                    };
                    if(s) {
                        subscriptionsRemove(channelId, false, dfn);
                    } else {
                        subscriptionsAdd(
                            channelId,
                            channelName,
                            eid('channel-picture').src,
                            false,
                            dfn
                        );
                    }
                });
            }
            
            break;
        case 'desc': showDescription(true); break;
        case 'share': shareot(channelUrl); break;
    }
}

/* the function goToSearchScreen is now in /common/js/data.js */

function showDescription(tr) {
    if(tr) {
        eid('channel-description-cont').focus();
        eid('channel-description-cont').scrollTo(0,0);
        document.body.classList.add('descshow');
        allowBack = false;
    } else {
        eid('channel-options').children[2].focus();
        document.body.classList.remove('descshow');
        allowBack = true;
    }
}

function keyHandler(k) {
    var df = actEl().id === 'channel-description-cont', 
    mv = (m)=>{if(!df){navigatelist(actEl().tabIndex,eid('channel-options').children,m);}};
    switch(k.key) {
        case 'Backspace': if(df){showDescription(false);} break;
        case 'SoftLeft': navMainMenu(0); break;
        case 'ArrowUp':   if(!df) { mv(-1); }break;
        case 'ArrowDown': if(!df) { mv( 1); }break;
        case 'Enter': if(!df) { selectItem(); }break;

    }
}
function localupdatenavbar() {
    outputNavbar(
        i18n('menu'),
        actEl().id === 'channel-description-cont'? '' : i18n('select'),
        ''
    )
}