var navbar = {
    "myself": document.getElementById('navbar'),
    "left": document.getElementById('navbar-left'),
    "right": document.getElementById('navbar-right'),
    "center": document.getElementById('navbar-center')
},

urlRegex = /((([A-Za-z]{3,9}:(?:\/\/)?)(?:[\-;:&=\+\$,\w]+@)?[A-Za-z0-9\.\-]+|(?:www\.|[\-;:&=\+\$,\w]+@)[A-Za-z0-9\.\-]+)((?:\/[\+~%\/\.\w\-_]*)?\??(?:[\-\+=&;%@\.\w_]*)#?(?:[\.\!\/\\\w]*))?)/,
//http://urlregex.com/

emptyFn = ()=>{}
;

function outputNavbar(l,c,r) {
    var na = [
        'left',
        'center',
        'right',
    ], 
    oa;

    if(Array.isArray(l)) {
        oa = l;
    } else {
        oa = [l,c,r];
    }

    for(var i = 0; i < 3; i++) {
        var cn = navbar[na[i]];
        if(oa[i] instanceof HTMLElement) {
            cn.innerHTML = '';
            oa[i].classList.add('icon');
            cn.appendChild(oa[i]);
        } else {
            cn.textContent = oa[i];
        }
    }
}
function createImg(path) {
    var i = document.createElement('img');
    i.src = path;
    return i;
}

navigator.mozAudioChannelManager.volumeControlChannel = 'content';

function eid(e){return document.getElementById(e)}
function ecls(e){return document.getElementsByClassName(e)}
function actEl(){return document.activeElement}

var timeformatHoursDisplay = getSettingValue('video-hours-time-display');
function timeformat(input) {
    var m = Math.floor(input / 60), s = Math.floor(input % 60), h = '';


    if(m > 59 && timeformatHoursDisplay) {
        h = Math.floor(m / 60) + ':';
        m = Math.floor(m % 60);
    } 
    if(m < 10) {
        m = '0' + m;
    }
    if(s < 10) {
        s = '0' + s;
    }
    return h + m + ':' + s;
}

function unixdatetimeformat(input) {return unixdateformat(input) + ' ' + unixtimeformat(input);}

function unixdateformat(input) { //expecting unix time seconds only; no milis. returns a string with year, month, day, hour, minute, and second
    var dateinit = new Date(input * 1000);
    var times = [
        dateinit.getFullYear(),
        dateinit.getMonth() + 1,
        dateinit.getDate()
    ];
    for(i=0;i<times.length;i++) {
        if(times[i] < 10) {times[i] = '0' + times[i];}
    }
    
    var rs = dateFormatDef;

    ['(y)', '(m)', '(d)'].forEach((v, i)=>{
        rs = rs.replace(v, times[i]);
    });

    return rs;
    //return times[0] + '-' + times[1] + '-' + times[2];
}

function unixtimeformat(input) { //expecting unix time seconds only; no milis. returns a string with year, month, day, hour, minute, and second
    var dateinit = new Date(input * 1000),
    times = [
        dateinit.getHours(),
        dateinit.getMinutes(),
        dateinit.getSeconds()
    ],
    zp = (n)=>{
        if(n < 10) {
            return '0' + n;
        } else {
            return n;
        }
    };

    var rs = timeFormatDef;

    ['(_hh)', '(_h)', '(hh)', '(h)', '(m)', '(s)', '(af)'].forEach((v)=>{
        if(rs.match(v)) {
            var x = '';
            switch(v) {
                case '(_hh)': x = zp(times[0]); break;
                case '(_h)':  x = times[0]; break;
                case '(hh)':  x = zp(times[0] % 12 || 12); break;
                case '(h)': x = (times[0] % 12) || 12; break;
                case '(m)': x = zp(times[1]); break;
                case '(s)': x = zp(times[2]); break;
                case '(af)': x = (times[0] < 12? i18n('time-am') : i18n('time-pm'))
            }
            rs = rs.replace(v, x);
        }
    });

    return rs;
}

function commaSeparateNumber(val){
    while (/(\d+)(\d{3})/.test(val.toString())){
      val = val.toString().replace(/(\d+)(\d{3})/, '$1'+','+'$2');
    }
    return val;
}

function randomizeArray(ia) {
    var oa = [];
    while(ia.length !== 0) {
        oa.push(ia.splice(Math.floor(Math.random() * ia.length), 1)[0]);
    }
    return oa;
}
function selectRandomFromArray(a) {
    return a[Math.floor(Math.random() * a.length)];
}

function makeThrobber(container) {
    var t = document.createElement('div');
    t.classList.add('throbber');
    if(container) {
        var c = document.createElement('div');
        c.appendChild(t);
        return c;
    }
    return t;
}

var animations = {
    fadeOut: (e)=>{
        animations.generic(e, 'fadeOutAnim');
    },
    
    generic: (e, cn)=>{
        e.classList.remove(cn);
        void(e.offsetHeight);
        e.classList.add(cn);
    }
};

function focusInput(ip) {
    ip.focus();
    var ln = ip.value.length;
    setTimeout(()=>{
        ip.setSelectionRange(ln,ln); 
    },1);
}

function navigatelist(index,list,move) { //RETURNS the current index of the thing.
    index += move;
    if(index >= list.length) {
        index = 0;
    } else if(index <= -1) {
        index = list.length - 1;
    }

    if(list[index] instanceof HTMLElement) {
        list[index].focus();
    }
    return index;
}

function elBounds(cn, el) {
    return {
        'ct': cn.scrollTop,
        'cb': cn.scrollTop + cn.clientHeight,
        'et': el.offsetTop,
        'eb': el.offsetTop + el.clientHeight
    }
}

function canseesc(cn,el) { //cn container, el,,, element
    var b = elBounds(cn, el);
    //IMPORTANT NOTE: IF USING THIS FUNCTION PLEASE MAKE SURE THAT THE PARENT IS POSITIONED
    //more info https://developer.mozilla.org/en-US/docs/Web/API/HTMLelement/offsetParent

    return ((b.eb <= b.cb) && (b.et >= b.ct)); //adapted from https://stackoverflow.com/a/488073
}

function canSeeElBounds(tp, cn, el) {
    var b = elBounds(cn, el);
    if(tp) {
        return b.et >= b.ct;
    } else {
        return b.eb <= b.cb;
    }
}

function scrolliv(el,dn,elpr) {
    if(elpr === undefined) {
        elpr = el.parentElement;
    }
    if(!canseesc(elpr,el)) {
        if(dn) { //going down
            el.scrollIntoView(false); //align to bottom
        } else { //going up
            el.scrollIntoView(true); //align to top
        }
    }
}

function lookfor(list,obj) {
    for(var i = 0; i < list.length; i++) {
        if(list[i] === obj) {
            return i;
        }
    }
}

function pJSON(r) {
    try {
        return JSON.parse(r);
    } catch(e) {
        console.log(e);
        return;
    }
}

function lazyLoadHandler(llrange,pivot,listCimage) {
    /* 
    llrange = lazyload range
    pivot = origin of lazyload image group
    listCimage = list Containing images
    */
    for(var i = llrange * -1; i < llrange; i++) {
        var cr = pivot.tabIndex + i;
        if(cr in listCimage) {
            if(!(listCimage[cr] instanceof HTMLImageElement)) {
                cr = listCimage[cr].getElementsByTagName('img');
                if(0 in cr) {
                    cr = cr[0];
                } else {
                    continue;
                }
            }
            if(cr.dataset.src) {
                cr.src = cr.dataset.src;
                cr.dataset.src = '';
            }
        }
    }
    
}



function alertMessage(message,disptime,type) {
    if(window.parent) {
		window.parent.alertMessage(message,disptime,type)
	}
}
    

var reloadOnHashChange = true;
window.addEventListener('hashchange',()=>{
    if(reloadOnHashChange) {
        location.reload();
    }
});


function updatenavbar() {
    switch(curpage) {
        case -1:
            outputNavbar(
                i18n('menu')
            )
            break;
        case 100:
        case 99:
            outputNavbar(
                i18n('back'), 
                i18n('select'), 
                ''
            ); break;
        case 98: outputNavbar(); break;
        default: localupdatenavbar(); break;
    }
    //console.log(`updatenavbar: curpage was ${curpage} at this time.`);
    //console.log(updatenavbar.caller);
}

function updateTheme() {
    var ct = getSettingValue('color-theme'),
    te = eid('color-theme');

    if(te) {
        te.remove();
    }

    if(ct !== 0) {
        var l = document.createElement('link');
        l.rel = 'stylesheet';
        l.type = 'text/css';
        l.id = 'color-theme';
        l.href = '/common/style/theme/' + [
            'shitty-light-theme',
            'prerandomized'
        ][ct - 1] + '.css';
        document.head.appendChild(l);
    }
}
updateTheme();

class OptionsMenu {
    constructor(headerLabel) {
        this.screen = document.createElement('div');
        this.screen.classList.add('screen','dim','hidden');

        this.container = document.createElement('div');
        this.container.classList.add('option-menu-cont');

        this.header = document.createElement('div');
        this.header.classList.add('menuheader');
        this.header.textContent = headerLabel;

        this.menu = document.createElement('div');
        this.menu.classList.add('option-menu');

        this.screen.appendChild(this.container);
        this.container.appendChild(this.header);
        this.container.appendChild(this.menu);
        document.body.appendChild(this.screen);
    }

    updateHeader(headerLabel) {
        this.header.textContent = headerLabel;
    }

    clearMenu() {
        var mc = this.menu.children;
        for(var i = 0; i < mc.length; i++) {
            mc[i].remove();
        }
    }

    navigate(d) {
        if(d === 0) {
            this.menu.children[0].focus();
        } else {
            navigatelist(
                actEl().tabIndex,
                this.menu.children,
                d
            )
        }
    }

    menuViewToggle(v,f,fn) {
        if(v) {
            this.screen.classList.remove('hidden');
            if(f) {
                if(isNaN(fn)) {fn = 0;}
                if(fn in this.menu.children) {
                    this.menu.children[fn].focus();
                }
            }
        } else {
            this.screen.classList.add('hidden');
        }
    }

    addOption(label) {
        var opt = document.createElement('div');
        opt.classList.add('option-entry');
        opt.tabIndex = this.menu.children.length;
        opt.textContent = label;
        this.menu.appendChild(opt);
        return opt;
    }
}

class OptionsMenuSelectable extends OptionsMenu {
    constructor(headerLabel, type, groupName) {
        super(headerLabel);

        validTypes = [
            'radio',
            'checkbox',
            'text',
            'tel'
        ];
    
        textTypes = [
            'text',
            'tel'
        ];

        if(!changeType(type)) {
            throw TypeError(`Type "${type}" is not valid.`);
        }
        this.inputType = type;
        if(!groupName) {groupName = Math.floor(Math.random() * Math.pow(10, 20));}
        this.groupName = groupName;
    }

    getSelected() {
        if(this.menu.children.length === 0) {return false;}

        var e,s,
        cb = ()=>{return this.menu.querySelector('input:checked')};

        switch(this.inputType) {
            case 'radio':
                e = cb()[0];
                s = parseInt(e.tabIndex);
                break;
            case 'checkbox':
                e = cb();
                s = [];
                for(var i = 0; i < e.length; i++) {
                    s.push(parseInt(e[i].tabIndex));
                }
                break;
            case 'text':
            case 'tel':
                e = this.menu.children[0];
                s = e.value;
                break;
        }

        return {
            value: s,
            element: e
        }
    }

    checkValidType(t) {
        return validTypes.indexOf(t) !== -1;
    }
    checkTextType(t) {
        return textTypes.indexOf(t) !== -1;
    }

    changeType(ntype) {
        if(checkValidType(ntype)) {
            this.clearMenu();
            this.inputType = ntype;
            if(checkTextType(ntype)) {
                this.addOption('');
            }
            return true;
        } else {
            return false;
        }
        
    }

    menuViewToggle(v,ft,n) {
        if(v) {
            if(ft === 2) {
                this.menu.querySelector('input:checked')
            }
        }

        super.menuViewToggle(v,ft,n);
    }

    addOption(label, selected) {
        var input = document.createElement('input');
        input.type = this.inputType;

        if(checkTextType(this.inputType)) {
            if(this.menu.children.length === 0) {
                input.tabIndex = 0;
                this.menu.appendChild(input);
                return input;
            } else {
                return null;
            }
        }

        var opt = super.addOption(label);
        
        input.name = this.groupName;
        input.checked = !!selected;

        opt.appendChild(input);
        return opt;
    }
}

class Tabs {
    constructor(appendToBody, existingContainer) {
        if(existingContainer) {
            this.container = existingContainer;
        } else {
            this.container = document.createElement('div');
        }
        this.container.classList.add('tabstrip-cont');

        this.tabStrip = document.createElement('div');
        this.tabStrip.classList.add('tabstrip');

        this.container.appendChild(this.tabStrip);

        this.tabs = {
            byNumber: [],
            byId: {}
        }

        if(appendToBody) {
            document.body.appendChild(this.container);
        }
    }

    addTab(label,id) {
        var ute = TypeError('you passed an unsupported type to removeTab(). Expected string or number.');

        var ct = document.createElement('div');
        ct.classList.add('tabstrip-tab');
        ct.textContent = label;
        if(!id) {
            var l = true;
            while(id in this.tabs.byId || l) {
                id = Math.random().toString();
                l = false;
            }
        }
        this.tabs.byId[id] = {
            element: ct,
            index: id
        };
        this.tabs.byNumber.push({
            element: ct,
            id: id
        });

        this.tabStrip.appendChild(ct);
    }

    removeTab(id) {
        switch(typeof(id)) {
            case 'string': 
                if(id in this.tabs.byId) {
                    var ct = this.tabs.byId[id], 
                    ix = this.tabs.byId[id].index;
                    ct.element.remove();
                    delete this.tabs.byId[id];
                    this.removeTab(ix);
                }
                break;
            case 'number': 
                if(id in this.tabs.byNumber) {
                    var ri = this.tabs.byNumber.splice(id,1)[0];
                    ri.remove();
                    this.removeTab(ri.id);
                }
                break;
            default: throw ute;
        }
    }

    focusTab(id) {
        this.tabs.byNumber.forEach((t)=>{
            t.element.classList.remove('active');
        });

        var activeTab;

        switch(typeof(id)) {
            case 'string': activeTab = this.tabs.byId; break;
            case 'number': activeTab = this.tabs.byNumber; break;
            default: throw ute;
        }

        activeTab = activeTab[id].element;
        activeTab.classList.add('active');

        this.tabStrip.scrollTo(
            activeTab.offsetLeft + (activeTab.offsetWidth / 2) - 
            (this.tabStrip.offsetWidth / 2)
        ,0);
    }
}

/* slightly unimportant */

function keyisnav(k) { return ['ArrowDown','ArrowUp','ArrowLeft','ArrowRight'].indexOf(k.key) > -1; }



/*  */
function goToWatchScreenWithPlaylist(listen,plid,vid,ind){
    var prms = new URLSearchParams();
    prms.append('listen',listen);
    prms.append('playlist', plid);
    prms.append('v',vid);
    prms.append('playlistindex', (ind));
    location = `/watch/index.html#${prms.toString()}`;
};
