var dateFormatDef = null, timeFormatDef = null;

function localizationInit() {
    console.log('localization init from', window.location);
    if(!('i18n' in window)) {
        window.i18n = window.parent.i18n;
    }
    dateFormatDef = window.parent.dateFormatDef;
    timeFormatDef = window.parent.timeFormatDef;
}

function localizationUpdateObjects(d) {
    if(d) {
        i18n.translator.add({
            values: d
        });
        
        sessionStorage.setItem('i18n-data', JSON.stringify(d));
    }

    dateFormatDef = [
        '(y)-(m)-(d)',
        '(y)/(m)/(d)',
        '(y).(m).(d)',
        '(m)-(d)-(y)',
        '(m)/(d)/(y)',
        '(m).(d).(y)',
        '(d)-(m)-(y)',
        '(d)/(m)/(y)',
        '(d).(m).(y)',
        i18n('date-format')
    ][getSettingValue('date-date-format') || 0];
    
    timeFormatDef = [
        '(_hh):(m):(s)',
        '(_h):(m):(s)',
        '(hh):(m):(s)(af)',
        '(h):(m):(s)(af)'
    ][getSettingValue('date-time-format') || 0];
}

localizationInit();
updateLocalization();

function updateLocalization() {
    var lces = document.getElementsByClassName('localization');

    for(var i = 0; i < lces.length; i++) {
        lces[i].innerHTML = i18n(lces[i].dataset.i18nid);
    }
}