function importFile(success,failure) {
    if(!success) {
        console.error('importFile: hey what are you even going to do with this file? (no success passed to importFile)');
        return;
    }
    if(!failure) {
        failure = emptyFn;
    }
    var lfa = new MozActivity({
        name: 'pick'
    });

    lfa.onsuccess = (res)=>{
        console.log(res);
	    res = res.target.result;

	    if(!('blob' in res)) {
            console.error('MozActivity resulted in success, however there is no blob available.');
            return;
        }
        
        var fr = new FileReader();
        fr.readAsText(res.blob);
        fr.onload = (r)=>{
            success(r.target.result);
        }
    };

	lfa.onerror = (e)=>{
        console.error(e);
        failure(e);
    }
}


function importSubscriptionsYoutube(r) {
    var rr = pJSON(r), f = 0, s = 0;
    if(Array.isArray(rr)) {
        progressDisplayVisToggle(true);
        var ce = -1,
        pd = new ProgressDisplayProgBars(i18n('settings-file-import-subscriptions') + ' '),
        nextImport = ()=>{
            ce++;
            pd.updatePercent(ce, rr.length - 1);
            if(ce === rr.length) {
                importSubscriptionsDone(s,f);
            } else {
                var e = rr[ce];
                try {
                    subscriptionsAdd(
                        e.snippet.resourceId.channelId,
                        e.snippet.title,
                        e.snippet.thumbnails.default.url,
                        true,
                        ()=>{
                            s++;
                            nextImport();
                        }
                    );
                } catch(e) {
                    f++;
                    nextImport();
                }
                
            }
        };

        nextImport();
    } else {
        alertMessage(i18n('settings-file-import-failed'),5000,3);
    }
}

function importSubscriptionsNewpipe(r) {
    
    var rr = pJSON(r), f = 0, s = 0, fail = ()=>{
        alertMessage(i18n('settings-file-parse-failed'),5000,3);
    };
    if(rr && 'subscriptions' in rr) {
        rr = rr.subscriptions;
        if(Array.isArray(rr)) {
            progressDisplayVisToggle(true);
            var pd = new ProgressDisplayProgBars(i18n('settings-file-import-subscriptions') + ' '),
            ce = -1, nextImport = ()=>{
                ce++;
                pd.updatePercent(ce, rr.length - 1);
                if(ce === rr.length) {
                    importSubscriptionsDone(s,f);
                } else {
                    var e = rr[ce];
                    try {
                        var id = e.url.substr('https://www.youtube.com/channel/'.length);
                        if(!subscriptionsCheck(id)) {
                            subscriptionsAdd(
                                id,
                                e.name,
                                null,
                                true,
                                ()=>{
                                    s++;
                                    nextImport();
                                }
                            );
                        }
                    } catch(e) {
                        f++;
                        nextImport();
                    }
                }
            };
            nextImport();
        } else {
            fail();
        }
    } else {
        fail();
    }
}

function importSubscriptionsDone(s,f) {
    var m = i18n('settings-subscription-import-count', s);
    if(f !== 0) {
        m += i18n('settings-subscription-import-fail-count', f);
    }

    alertMessage(m,5000,1);
    progressDisplayVisToggle(false);
}

var settingsImportInProgress = false;
function settingsImport(f) {
    file = pJSON(f);

    var historyProg = 0;

    if(file) {
        settingsImportInProgress = true;
        progressDisplayVisToggle(true);
        progressDisplay(i18n('import-progress-file-successfully-parsed'));

        var subscriptionsDone = false, 
        historyDone = false,
        checkAllDone = ()=>{
            if(subscriptionsDone && historyDone) {
                progressDisplay(i18n('import-progress-okay-all-done'));
                setTimeout(
                    window.parent.fullReload,
                    1000
                );
            }
        };

        if('settings' in file) {
            var importSts = Object.keys(file.settings),
            existingSts = Object.keys(settingsList);
            for(var i = 0; i < importSts.length; i++) {
                var csts = importSts[i];
                if(existingSts.indexOf(csts) !== -1) {
                    if([4,5].indexOf(settingsList[csts].type) === -1) {
                        updateSetting(
                            csts,
                            JSON.stringify(file.settings[csts]),
                            true
                        );
                        if('action' in settingsList[csts]) {
                            settingsList[csts].action();
                        }
                    }
                }
            }

            progressDisplay(i18n('import-progress-settings-updated', {u: importSts.length}));
        }

        var historyCheckAllDone = ()=>{
            historyDone = true;
            checkAllDone();
        };
        window.parent.allPageHistory.clear().then(()=>{
            if('history' in file) {

                var th = file.history,
                histProgDisp = new ProgressDisplayProgBars(i18n('history') + ' '),
                pushHistFromFile = ()=>{
                    pushToAllHistory(
                        th[historyProg].id,
                        th[historyProg].type,
                        th[historyProg].name || ('ID: '+ th[historyProg].id),
                        th[historyProg].exdata || {},
                        th[historyProg].time,
                        ()=>{
                            historyProg++;

                            histProgDisp.updatePercent(historyProg, th.length);

                            if(historyProg === th.length) {
                                historyCheckAllDone();
                            } else {
                                //setTimeout(pushHistFromFile, 500);
                                pushHistFromFile();
                            }
                        }
                    )
                }
                pushHistFromFile();
            } else {
                historyCheckAllDone();
            }
        });

        var subscriptionsCheckAllDone = ()=>{
            subscriptionsDone = true;
            checkAllDone();
        };
        channelSubscriptions.clear().then(()=>{
            if('subscriptions' in file) {
                var sf = file.subscriptions, sbs = Object.keys(sf),
                histProgDisp = new ProgressDisplayProgBars(i18n('subscriptions-menu-item') + ' '),
                subscriptionsProcessed = 0;
    
                console.log(sf);
    
                for(var i = 0; i < sbs.length; i++) {
                    subscriptionsAdd(
                        sbs[i],
                        sf[sbs[i]].name,
                        sf[sbs[i]].img,
                        true,
                        ()=>{
                            subscriptionsProcessed++;
    
                            histProgDisp.updatePercent(subscriptionsProcessed, sbs.length);
    
                            if(subscriptionsProcessed === sbs.length) {
                                subscriptionsCheckAllDone();
                            }
                        }
                    );
                }
            } else {
                subscriptionsCheckAllDone();
            }
        });
    } else {
        alertMessage(i18n('settings-file-parse-failed'), 5000, 3);
    }
}   





function settingsExport() {
    progressDisplayVisToggle(true);

    var exp = {
        settings: {},
        subscriptions: {},
        history: []
    },
    subscriptionsReady = false,
    historyReady = false,
    
    allDone = ()=>{ //this is called when everything is done.
        if(
            subscriptionsReady && 
            historyReady
        ) {
            var blb = new Blob([JSON.stringify(exp)]),
            blblink = document.createElement('a');
    
            blblink.download = i18n('settings-file-export-name') + (new Date()).getTime() + '.json';
            blblink.href = URL.createObjectURL(blb);
            document.body.appendChild(blblink);
            blblink.click();
            blblink.remove();
            setTimeout(()=>{
               URL.revokeObjectURL(blblink.href);
            },5000); 

            progressDisplayVisToggle(false);
        }
    };

    /* settings */
    Object.keys(settingsList).forEach((e)=>{
        if([4,5].indexOf(settingsList[e].type) === -1) {
            exp.settings[e] = getSettingValue(e);
        }
    });

    /* subscriptions */
    var chnProgDisp = new ProgressDisplayProgBars(i18n('subscriptions-menu-item') + ' ');
    channelSubscriptions.length().then((length)=>{
        var sp = 0;
        channelSubscriptions.iterate((v,i)=>{

            mdataStore.getItem(i).then((data)=>{
                exp.subscriptions[i] = {
                    name: data.name,
                    img: data.image
                };

                sp++;

                chnProgDisp.updatePercent(sp, length)

                if(sp === length) {
                    subscriptionsReady = true;
                    allDone();
                }
            });
        });
    });

    /* history */
    var aph = window.parent.allPageHistory, 
    aphlen = 0, 
    aphProgDisp = new ProgressDisplayProgBars(i18n('history') + ' '),
    historyProgressCheck = (p)=>{
        exp.history.push(p);

        aphProgDisp.updatePercent(exp.history.length, aphlen);

        if(exp.history.length === aphlen) {
            historyReady = true;
            allDone();
        }
    };

    aph.length().then((length)=>{
        aph.getItem('lastItem').then((liexists)=>{
            if(liexists !== null) {length--;}

            aphlen = length;
            length = undefined;

            aph.iterate((v)=>{
                var po = {
                    id: v.id,
                    name: null,
                    type: v.type,
                    time: v.time
                };
                if(v.type === 'search') {
                    po.name = v.name;
                    historyProgressCheck(po);
                } else {
                    mdataStore.getItem(v.id).then((data)=>{
                        if(data !== null) {
                            po.name = data.name;
                        } else {
                            po.name = 'ID: ' + v.id;
                        }

                        historyProgressCheck(po);
                    });
                }
            });
        });
        
    });
}