var
currentSetting = {index: 0, name: ''},
currentCategory = 'default',
settingNavigationHistory = [],
curpage = 0;

window.addEventListener('DOMContentLoaded',()=>{
    if(location.hash === '#bootup') {
        console.log('app has been started.');
        sessionStorage.setItem('apprunning',true);
        initSettings(0,true);

        setTimeout(()=>{
            var ifr = localStorage.getItem('firstrun');

            if(ifr !== versionNumber) {
                localStorage.setItem('firstrun', versionNumber);
            }

            if(ifr === null) {
                window.parent.fullReload();
            } else {
                location = '/home/index.html';
            }
        }, 10); /* putting in a set timeout because of a bug that breaks the launch screen and window.close() function if you window.alert right away */
        } else {
        eid('loading-indicator').remove();
        pushHistory('settingspage');
        disableControls = false;
        eid('main').classList.remove('hidden');
        initSettings(0);
        updatenavbar();
    }
});

function initSettings(focusIndex, updateAll) {
    eid('settings-list').innerHTML = '';
    var st = updateAll? Object.keys(settingsList) : settingsListCategories[currentCategory].settings,
    addedElements = 0;

    for(var i = 0; i < st.length; i++) {
        var csn = st[i],
        cs = settingsList[csn],
        op = [
            document.createElement('div'),
            document.createElement('div'),
            document.createElement('div'),
            document.createElement('div')
        ],
        hasvalue = getSettingValue(csn) === null && [4,5].indexOf(cs.type) === -1;

        if(hasvalue) {
            updateSetting(csn, cs.default, true);
            if(updateAll) {continue}
        }

        //layer 01
        op[0].classList.add('setting', 'focusable-item');
        op[0].dataset.setting = csn;
        op[0].tabIndex = addedElements;

        //layer 02
        op[1].classList.add('vertical-center');

        //layer 03
        //setting name
        op[2].classList.add('setting-name');
        op[2].textContent = getSettingLabel(csn);

        //setting value
        if(!hasvalue) {
            op[3].classList.add('setting-value');
            op[3].textContent = getFormattedSettingValue(csn);
        }

        /* 
        <0>
            <1>
                <2>name</2>
                <3>value</3>
            </1>
        </0>
        */
        op[1].appendChild(op[2]);
        op[1].appendChild(op[3]);
        op[0].appendChild(op[1]);
        eid('settings-list').appendChild(op[0]);
        addedElements++;
    }

    eid('settings-list').children[focusIndex].focus();
    eid('settings-list').children[focusIndex].scrollIntoView(false);
    currentSetting.name = actEl().dataset.setting;
    currentSetting.index = focusIndex;
}

function updateSetting(setNm,newVal,noParse) {
    if(setNm in settingsList) {
        if(!noParse && typeof(newVal) !== 'string') {newVal = JSON.stringify(newVal);}
        localStorage.setItem(getSettingKey(setNm), newVal);

        console.log('The setting', setNm, 'has been updated to', newVal);
    }
}

function updateActiveSettingDisplay() {
    ecls('setting')[currentSetting.index].getElementsByClassName('setting-value')[0].textContent = getFormattedSettingValue(currentSetting.name);
}

function getFormattedSettingValue(setNm) {
    if(setNm in settingsList) {
        var cs = settingsList[setNm],
        csv = getSettingValue(setNm);

        switch(cs.type) {
            case 0: 
                return getSettingValueLabel(setNm, csv);
            case 1:
                if(csv.length === 0) {
                    return i18n('settings-valuenone');
                } else {
                    for(var i = 0; i < csv.length; i++) {
                        csv[i] = getSettingValueLabel(setNm, csv[i]);
                    }
                    return csv.join(i18n('comma-separator'));
                }
            case 2:
            case 3:
                return csv;
        }
    }
}

function showSettingChangeDialog() {
    curpage = 1;
    allowBack = false;
    eid('setting-change-display').innerHTML = '';
    eid('setting-change-display-screen').classList.remove('hidden');
    
    eid('setting-change-display-header').textContent = getSettingLabel(currentSetting.name);

    var cs = settingsList[currentSetting.name],
    cv = getSettingValue(currentSetting.name);


    if(cs.type < 2) {
        var focusOverride = 0;
        for(var i = 0; i < cs.values; i++) {
            var ac = document.createElement('div'),
            ipc = document.createElement('span'),
            ipl = document.createElement('span'),
            ip = document.createElement('input');
    
            ac.classList.add('option-entry');
            ac.tabIndex = i;
            ip.name = 'setting'; //to put them in the same group

            ipc.appendChild(ip);
            ipc.appendChild(ipl);
            ipc.classList.add('input');
            
            ac.textContent = getSettingValueLabel(currentSetting.name, i);
    
            switch(cs.type) {
                case 0:
                    ip.type = 'radio';
                    if(i === cv) {
                        ip.checked = true;
                        focusOverride = i;
                    }
                    ac.appendChild(ipc);
                    break;
                case 1:
                    ip.type = 'checkbox';
                    if(cv.indexOf(i) !== -1) {
                        ip.checked = true;
                    }
                    ac.appendChild(ipc);
                    break;
            }
    
            eid('setting-change-display').appendChild(ac);
        }

        console.log(focusOverride);
        eid('setting-change-display').children[focusOverride].focus();
    } else {
        eid('setting-change-display').classList.add('has-text-input');
        var ip = document.createElement('input');
        ip.classList.add('setting-text-input');
        switch(cs.type) {
            case 2: //number
                ip.type = 'tel'; 
                up.classList.add('number');
                break;
        }

        ip.value = cv;

        eid('setting-change-display').appendChild(ip);
        focusInput(ip);
    }

}

function hideSettingChangeDialog() {
    curpage = 0;
    ecls('setting')[currentSetting.index].focus();
    eid('setting-change-display').classList.remove('has-text-input');
    eid('setting-change-display-screen').classList.add('hidden');
    allowBack = settingNavigationHistory.length === 0;
}

manageSettingsPageHistory = {
    append: (category, index) => {
        settingNavigationHistory.push({
            category: category,
            index: index
        });

        allowBack = false;
    },

    back: () => {
        var li = settingNavigationHistory.pop();
        if(li) {
            currentCategory = li.category;
            updateHeader();
            initSettings(li.index);
        }

        if(settingNavigationHistory.length === 0) {
            allowBack = true;
        }
    }
}

function getSettingLabel(sn) {return i18n('settings-label-' + sn);}
function getSettingValueLabel(sn,i) {return i18n(`settings-value-${sn}-${i}`)}

function updateHeader() {
    
    eid('header').textContent = getSettingLabel('category-' + currentCategory);
}


function doubleConfirmAction(t,a) {
    if(window.confirm(t + '\n\n' + i18n('settings-double-confirm-1'))) {
        if(window.confirm(t + '\n\n' + i18n('settings-double-confirm-2'))) {
            a();
        }
    }
}


function localupdatenavbar() {
    switch(curpage) {
        case 0:
            outputNavbar(
                i18n('menu'),
                i18n('select'),
                i18n('help')
            );
            break;
        case 1:
            outputNavbar(
                i18n('back'),
                settingsList[currentSetting.name].type < 2? i18n('select') : i18n('save'),
                ''
            );
            break;
    }
}

function navigateSettings(dir) {
    currentSetting.index = navigatelist(
        actEl().tabIndex,
        ecls('setting'),
        dir
    );
    scrolliv(actEl(), dir === 1);
    currentSetting.name = actEl().dataset.setting;
    currentSetting.index = actEl().tabIndex;
}

function keyHandler(k) {
    switch(curpage) {
        case 0: mainScreenK(k); break;
        case 1: settingChangeK(k); break;
    }
}

function mainScreenK(k) {
    switch(k.key) {
        case 'ArrowUp': 
            navigateSettings(-1); 
            k.preventDefault();
            break;
        case 'ArrowDown': 
            navigateSettings(1); 
            k.preventDefault();
            break;
        case 'SoftLeft': navMainMenu(0); break;
        case 'SoftRight':
            window.alert(i18n('settings-desc-' + currentSetting.name));
            break;
        case 'Enter': 
            var cs = settingsList[currentSetting.name];
            switch(cs.type) {
                case 4: cs.action(); break;
                case 5:
                    manageSettingsPageHistory.append(
                        currentCategory,
                        currentSetting.index
                    );
                    currentCategory = cs.action;
                    updateHeader();
                    initSettings(0);
                    break;
                default: showSettingChangeDialog(); break;
            }
            break;
        case 'Backspace':
            manageSettingsPageHistory.back();
            break;
    }
}

function settingChangeK(k) {
    switch(k.key) {
        case 'ArrowUp': 
            navigatelist(
                actEl().tabIndex, 
                eid('setting-change-display').children, 
                -1
            ); 
            break;
        case 'ArrowDown': 
            navigatelist(
                actEl().tabIndex, 
                eid('setting-change-display').children, 
                1
            ); 
            break;
        case 'SoftLeft':
            hideSettingChangeDialog();
            break;
        case 'Enter': 
            switch(settingsList[currentSetting.name].type) {
                case 0:
                    updateSetting(currentSetting.name, actEl().tabIndex);
                    hideSettingChangeDialog();
                    break;
                case 1:
                    var ol = eid('setting-change-display').children,
                    sts = [];

                    actEl().getElementsByTagName('input')[0].checked = !(actEl().getElementsByTagName('input')[0].checked);

                    for(var i = 0; i < ol.length; i++ ) {
                        if(ol[i].getElementsByTagName('input')[0].checked) {
                            sts.push(i);
                        }
                    }
                    updateSetting(currentSetting.name, sts);
                    break;
                case 3:
                    if('check' in settingsList[currentSetting.name]) {
                        if(!settingsList[currentSetting.name].check(actEl().value)) {
                            alertMessage(i18n('settings-invalid-input'), 5000, 3);
                            break;
                        }
                    }
                case 2:
                    updateSetting(currentSetting.name, actEl().value);
                    hideSettingChangeDialog();
                    break;
            }

            if('action' in settingsList[currentSetting.name]) {
                settingsList[currentSetting.name].action();
            }

            updateActiveSettingDisplay();

            break;

        case 'Backspace': 
            hideSettingChangeDialog();
            if(settingsList[currentSetting.name].type > 1) {
                alertMessage(i18n('settings-setting-discarded'),5000,1);
            }
            break;

    }
}