var captions, 
captionLoadId, 
captionLoading = false, 
captionsCurrent = -1,
captionsMenu = new OptionsMenu(i18n('video-action-captions-menu'))
;

function loadCaption(id) {
    captionLoadId = id;
    freedatagrab(
        rqApi.base + captions[id].url,
        loadCaptionDone,
        loadCaptionFail,
        false,
        false
    );

    alertMessage(i18n('captions-loading'),5000,1);
}
function loadCaptionDone(rqResp) {
    captions[captionLoadId].data = new Blob([
        rqResp
    ]);
    captions[captionLoadId].dataUrl = URL.createObjectURL(captions[captionLoadId].data);

    var e = captions[captionLoadId], trk = document.createElement('track');
    trk.kind = 'captions';
    trk.label = e.label;
    trk.id = captionLoadId;
    trk.src = URL.createObjectURL(captions[captionLoadId].data);

    trk.onerror = (e)=>{
        console.error(e);
        alertMessage(i18n('captions-loaded-invalid'),5000,3);
        captions[captionsCurrent].data = null;
        captionsCurrent = -1;
    }
    output.video.appendChild(trk);
    setTimeout(()=>{selectCaption(captionLoadId);},1);
    alertMessage(i18n('captions-loaded'),1000,0);
}

function loadCaptionFail() {
    alertMessage(
        i18n('captions-load-fail', {lang: captions[captionLoadId].label}),
        5000,3
    );

}

function selectCaption(index) {
    var vt = output.video.textTracks;
    for(var i = 0; i < vt.length; i++) {
        vt[i].mode = 'hidden';
        vt[i].removeEventListener('cuechange',renderCaptions);
    }
    captionsCurrent = index;
    if(index === -1) {
        renderCaptionsClear();
    } else {

        if('data' in captions[index]) {
            initialCaptionRender();
        } else {
            loadCaption(index);
        }
    }
}

function initialCaptionRender() {
    var c = output.video.textTracks.getTrackById(captionsCurrent);
    if(c) {
        c.addEventListener('cuechange',renderCaptions);
        renderCaptionsActual(c.activeCues);
        console.log(`initialCaptionRender: showed the captions for ${c.label}`);
    } else {
        setTimeout(initialCaptionRender,100);
    }
}

function attachCueChangeHandler() {
    output.video.textTracks.getTrackById(captionsCurrent)
        .addEventListener('cuechange',renderCaptions);
}

function navCaption(mv) {
    navigatelist(
        actEl().tabIndex,
        captionsMenu.menu.children,
        mv
    );
}

function captionK(k) {
    switch(k.key) {
        case 'ArrowDown':  navCaption(1); break;
        case 'ArrowUp':    navCaption(-1);break;
        case 'Enter':      selectCaption(actEl().tabIndex - 1); //dont break, continue to exit action.
        case 'SoftLeft':
        case 'Backspace':
            captionMenuShow(false);break;
    }
}

var captionLastEl = null;
function captionMenuShow(tr) {
    if(captionLoading) {
        alertMessage(i18n('captions-wait-for-previous'),5000,2);
        return;
    }
    
    if(tr) {
        if(captions.length === 0) {
            alertMessage(i18n('captions-not-available'),5000,1);
            return;
        }
        captionLastEl = actEl();
        captionsMenu.menuViewToggle(true);
        captionsMenu.menu.children[captionsCurrent + 1].focus();
        curpage = 4;
    } else {
        captionLastEl.focus();
        captionsMenu.menuViewToggle(false);
        curpage = 2;
    }
}
