var commentsLoaded = 0,
commentsLoading = false,
commentsContinuation = null,
commentsDisplayCount = 0,
commentsRequester = null,
commentsImagesNotLoaded = [],
commentsImagesEnabled = true,

commentsLoadMoreElId = 'data-comments-load-more',
commentsThrobberId = 'data-comments-loading';

document.addEventListener('DOMContentLoaded',()=>{
    eid('data-comments').addEventListener('scroll',()=>{
        updatenavbar();
    });
});

function getMoreCommentsAllowed() {
    var cs = eid('data-comments');
    return cs.scrollHeight === cs.scrollTop + cs.clientHeight &&
    !!commentsContinuation &&
    !commentsLoading;
}

function navigateComments(move) {
    var c = eid('data-comments');
    if(canSeeElBounds(
        move < 0,
        c, 
        actEl()
    )) {
        navigatelist(
            actEl().tabIndex,
            c.children,
            move
        );
        if(
            actEl().clientHeight < c.clientHeight &&
            !canseesc(c, actEl())
        ) {
            actEl().scrollIntoView(move < 0);
        }
        return true;
    }
    return false;
}

function navigateCommentsFF() {
    eid('data-comments').children[0].focus();
}

function navigateCommentsCurrentExpandable() {
    return actEl().classList.contains('expandable');
}
function navigateCommentsUpdateNavbar() {
    var a = [i18n('back'),'',''];

    if(
        actEl().id === commentsLoadMoreElId &&
        !commentsLoading
    ) {
        a[1] = i18n('load');

    } else if(navigateCommentsCurrentExpandable()) {
        if(actEl().classList.contains('expanded')) {
            a[1] = i18n('hide');
        } else {
            a[1] = i18n('more');
        }
    }
    return a;
}

function navigateCommentsEnter() {
    var a = actEl();
    if(a.id === commentsLoadMoreElId && !commentsLoading) {
        getComments();
    } else if(navigateCommentsCurrentExpandable()) {
        if(a.classList.contains('expanded')) {
            a.classList.remove('expanded');
            if(!canseesc(eid('data-comments'), a)) {
                a.scrollIntoView(true); //align to top
            }
        } else {
            a.classList.add('expanded');
        }
    }
}

function getComments() {
    if(commentsLoading) {return}
    var cnt = '';
    if(commentsContinuation) {
        cnt = '&continuation=' + commentsContinuation;
    }

    commentsRequester = requestItem(
        'comments',
        videoId,
        cnt,
        outputComments,
        commentsFailure,
        false,
        true
    );
    var cn = document.createElement('center');
    cn.id = commentsThrobberId;
    cn.appendChild(makeThrobber());
    if(commentsLoaded === 0) {
        cn.classList.add('center');
        eid('data-comments').textContent = '';
        eid('data-comments').scrollTop = 0;
        eid('data-comments').appendChild(cn);
    } else {
        eid(commentsLoadMoreElId).innerHTML = '';
        eid(commentsLoadMoreElId).appendChild(cn);
    }
    if(commentsLoaded > 0) {
        eid('data-comments').scrollTop = eid('data-comments').scrollHeight - eid('data-comments').clientHeight;
    }
    commentsLoading = true;
    commentsLoaded++;
}

function outputComments(rs) {
    console.log(rs);

    var cs = rs.comments;

    if('continuation' in rs) {
        commentsContinuation = rs.continuation;
    } else {
        commentsContinuation = null;
    }
    
    if(commentsLoaded === 1) {
        eid('data-comments').innerHTML = '';
        
        if(cs.length === 0) {
            var fm = document.createElement('div');
            fm.classList.add('center');
            fm.textContent = i18n('video-info-no-comments');
            eid('data-comments').appendChild(fm);
            return;
        } else {
            infoTabDisplay.tabs.byId['comments'].element.textContent += ` (${commaSeparateNumber(rs.commentCount)})`;
            infoTabDisplay.focusTab(infoTab);

        }
    } else if(commentsLoaded > 1) {
        eid(commentsLoadMoreElId).remove();
    }

    for(var i = 0; i < cs.length; i++) {
        var cur = cs[i],
        allContainer = document.createElement('div'),
        cme = document.createElement('div'),
        cmet = document.createElement('div'),
        cmem = document.createElement('div'),
        nm = document.createElement('div'),
        cmd = document.createElement('div'),
        clikes = document.createElement('span'),
        clikesico = document.createElement('img'),
        cdate = document.createElement('span');

        cmet.textContent = cur.content;
        cmet.classList.add('data-comments-comment');

        cme.classList.add('data-comments-comment-container');
        cme.appendChild(cmet);
 
        if(commentsImagesEnabled) {
            var pic = document.createElement('img'),
            picsrc = imgChoose(cur.authorThumbnails,'width',100);
            pic.classList.add('data-comments-img');
            pic.src = picsrc;
            
            cmem.appendChild(pic);
        } else {
            cme.classList.add('data-comments-comment-container-noimg')
        }
        cmem.appendChild(cme);

        cmd.classList.add('data-comments-metadata');
        clikesico.src = '/img/rating/up-mc.png';
        clikesico.classList.add('icon');
        clikes.appendChild(clikesico);
        clikes.innerHTML += commaSeparateNumber(cur.likeCount);
        clikes.classList.add('data-comments-metadata-likes');
        cdate.textContent = unixdatetimeformat(cur.published);
        if(cur.isEdited) {
            cdate.textContent += ' (edit)';
        }
        cmd.appendChild(cdate); 
        cmd.appendChild(clikes);

        nm.classList.add('data-comments-name');
        if(cur.authorIsChannelOwner) {
            nm.classList.add('data-comments-name-channelowner');
        }
        nm.textContent = cur.author;

        allContainer.tabIndex = commentsDisplayCount;

        allContainer.appendChild(nm);
        allContainer.appendChild(cmem);
        allContainer.appendChild(cmd);
        eid('data-comments').appendChild(allContainer);

        var hi = allContainer.clientHeight;
        allContainer.classList.add('expandable', 'expanded');
        var hf = allContainer.clientHeight;

        if(hi === hf) {
            allContainer.classList.remove('expandable');
        } else {
            var mi = document.createElement('div');
            mi.classList.add('data-comments-comment-expand-prompt');
            mi.textContent = i18n('more-ellipses');
            cme.appendChild(mi);
        }
        allContainer.classList.remove('expanded');

        if(commentsLoaded > 1 && i === 0) {
            allContainer.focus();
        }

        commentsDisplayCount++;
    }

    if(commentsContinuation) {
        var lm = document.createElement('div');
        lm.id = commentsLoadMoreElId;
        lm.textContent = i18n('load-more-ellipses');
        lm.tabIndex = commentsDisplayCount;
        eid('data-comments').appendChild(lm);
    }

    commentsLoading = false;
    if(commentsLoaded === 1) {
        navigateCommentsFF();
    }
    updatenavbar();
}

function commentsFailure(e) {
    alertMessage(i18n('video-info-comments-failed-to-load'), 5000, 2);
    if(commentsLoaded === 1) {
        eid('data-comments').innerHTML = '';
        var fm = document.createElement('div');
        fm.classList.add('center');
        fm.style.textAlign = 'center';
        fm.textContent = i18n('video-info-comments-failed-to-load');
        eid('data-comments').appendChild(fm);
    } else {
        eid(commentsLoadMoreElId).textContent = i18n('load-more-ellipses');
    }
    commentsLoading = false;
    commentsLoaded--;
}