var lcHash, 
videoId, 
channelId, 
channelName,
listenMode = false, 
continueTime = 0, 
videoLength,
noRelateds = true,
playlistId,
playlistIndex = 0,
playlistItems = [];

function init() {
    curpage = -1;
    updatenavbar();
    disableControls = false;
    allowBack = true;

    alraedyBeganPlaying = false;
    videoAbleToPlay = false;
    tallVideo = true;
    noRelateds = true;
    eid('actions-vertical-positioner').classList.add('vertical-center');
    eid('actions-relatedvids-cont-wt').classList.add('hidden');
    eid('actions-relatedvids-loading-placeholder').classList.add('hidden'); 

    if(commentsLoading) {
        commentsRequester.abort();
    }
    commentsLoaded = 0;
    commentsLoading = false;
    commentsDisplayCount = 0;
    commentsContinuation = null;
    infoTabDisplay.tabs.byId['comments'].element.textContent = i18n('video-info-comments');

    if(output.video) {
        output.video.pause();
        output.video.remove();
        output.video = null;

        if(output.audio) {
            output.audio.pause();
            output.audio = null;
        }
    }

    eid('videoErrorOverlay').classList.add('hidden');
    eid('videoErrorText').textContent = i18n('video-screen-error-failed-to-load');
    eid('data-extraAlert').innerHTML = '';

    eid('data-rating').classList.remove('hidden');
    eid('data-rating-description-all-container').classList.remove('disabledRatings');

    output.videoTime.text.textContent = '00:00';
    output.videoTime.textSub.textContent = '00:00';
    output.videoTime.bar.style.width = null;

    eid('unlisted-video-indicator').classList.add('hidden');
    eid('loop-indicator').classList.add('hidden');
    updateStatusIcon('wait');

    output.title.textContent = i18n('loading');
    output.author.textContent = i18n('nanashi');
    output.data.published.textContent = '20xx-xx-xx';
    output.data.viewcount.textContent = '--';
    output.data.rating.like.textContent = '--';
    output.data.rating.dislike.textContent = '--';


    lcHash = location.hash.substr(1);

    if(lcHash) {
        var prms = new URLSearchParams(lcHash), 
            plm = prms.get('playlist'); 
        videoId = prms.get('v');
        listenMode = prms.get('listen') === 'true';
        continueTime = Number(prms.get('t'));
        playlistMode = !(plm === '' || plm === null),
        
        histExData = {};

        if(playlistMode) {histExData.playlist = playlistId;}

        reloadOnHashChange = false;
        pushHistory(videoId,'video',videoId, histExData);
        pushToAllHistory(videoId,'video');

        switch((playlistMode << 1) + !!videoId) {
            case 3:
                playlistId = plm;
                loadPlaylistInit();
                //break;
            case 1:
                loadVideo(videoId);
                break;
            default:
                console.error('init: unhandled combination.');
        }
    } else {
        promptVideo();
        videoLoaderShow(true,i18n('please-wait'));
        pushHistory('dummy');
    }
}

window.addEventListener('DOMContentLoaded',()=>{
    if(getSettingValue('sekibanki-loading-icon') === 0) {
        ecls('bankihead-loader')[0].remove();
    }

    if(getSettingValue('video-time-display') === 2) {
        eid('videoTimeTextSub').classList.remove('hidden');
    }

    if(getSettingValue('video-always-show-time') === 1) {
        document.body.classList.add('minitimebar');
    }

    if(!getSettingValue('listen-mode-show-listen-mode-on-thumbnail')) {
        eid('audioModeDisplay').classList.add('notext');
    }

    if(getSettingValue('listen-mode-blurry-thumbnail')) {
        eid('audioModeDisplay-img').classList.add('blur');
    }

    if(segmentSkipping.userCategories.length !== 0) {
        var ss = videoActionOverflowMenu.addOption('');
        ss.innerHTML = '<span id="segment-skipping-temp-disable-toggle"></span>';
        ss.dataset.action = 'toggle-segment-skipping';
    }
    
    init();
    console.log('loaded');
    }
);

function loadVideo(id) {
    var cachedVid = itemCache('video', id, 'get');
    if(cachedVid) {
        console.log('loadVideo: got data from cache instead.');
        initRqDone(cachedVid);
    } else {
        requestItem(
            'videos',
            id,
            '',
            (r)=>{
                itemCache('video', videoId, 'update', r);
                initRqDone(r);
            },
            initRqError,
            false,
            true
        );    
    }

    getSkipSegments();

    videoLoaderShow(true,i18n('loading'));
}
function loadAnotherVideo(id) {
    var prms = new URLSearchParams();
    prms.append('v',id);
    prms.append('listen',listenMode);
    if(playlistMode) {
        prms.append('playlist',playlistId);
    }
    location.hash = prms.toString();
    exitToMain();
    init();
}
var output = {
    title: eid('data-title'),
    fullTitle: eid('data-fullTitle'),
    author: eid('data-author'),
    fullAuthor: eid('data-fullAuthor'),
    description: eid('data-description'),
    videoCont: eid('videoCont'),
    video: null,
    audio: null,
    mediaLoaded: [0,0], //loaded / expected
    authorPic: eid('actions-video-channel'),
    videoTime: {
        bar: eid('videoTimeIn'),
        text: eid('videoTimeTextMain'),
        textSub: eid('videoTimeTextSub')
    },
    data: {
        published: eid('data-published'),
        publishedDesc: eid('data-fullpublished'),
        viewcount: eid('data-viewcount'),
        viewcountDesc: eid('data-fullviewcount'),
        videoId: eid('data-videoId'),
        category: eid('data-category'),
        runtime: eid('data-runtime'),
        thumbnail: eid('data-thumbnail'),
        rating: {
            like: eid('data-rating-like'),
            dislike: eid('data-rating-dislike'),
            likePercent: eid('data-rating-like-percent'),
            votePercent: eid('data-rating-voted-percent'),
            likePercentBar: eid('data-rating-like-percent-bar'),
            dislikePercentBar: eid('data-rating-dislike-percent-bar')
        }
    }
}
;

function initRqError(e) {
    console.log(e);
    try {
        e = JSON.parse(e.response);
    } catch(e) {}

    output.title.textContent = `${i18n('error')} [ID: ${videoId}]`;
    updateStatusIcon('warning');
    
    eid('videoErrorOverlay').classList.remove('hidden');

    var eo = '';

    if(typeof(e) !== 'string') {
        if('error' in e) {
            switch(e.error) {
                case 'Sign in if you\'ve been granted access to this video': 
                    eo = i18n('video-screen-error-private'); break;
                default: eo = e.error; break;
            }
        } else {
            eo = i18n('unknown-error');
        }
    } else {
        switch(e.status) {
            case 403:
                eo = i18n('video-screen-error-403');
                break;
            case 500:
                eo = i18n('video-screen-error-500');
                break;
            default:
                eo = i18n('video-screen-error-nnn', {code: e.status});
                break;
        }
    }

    eid('videoErrorText').textContent = eo;
}

function initRqDone(rqResp) {
    var histExData = {};
    if(playlistMode) {histExData.playlist = playlistId;}
    pushHistory(videoId,'video',rqResp.title,histExData);
    //pushToAllHistory(videoId,'video',rqResp.title);
    var videoThumbnail = thumbchoose(rqResp.videoThumbnails);
    mdataStoreSet(
        videoId,
        {
            name: rqResp.title,
            type: 'video',
            author: {
                name: rqResp.author,
                id: rqResp.authorId
            },
            time: rqResp.published,
            image: videoThumbnail
        }
    );

    videoId = rqResp.videoId;
    localStorage.setItem('recentVideo',videoId);
    channelId = rqResp.authorId;
    videoLength = rqResp.lengthSeconds;
    captions = rqResp.captions;

    if('error' in rqResp) {
        if(!/Could not extract video info. Instance is likely blocked./i.test(rqResp.error)) {
            eid('videoErrorText').textContent = rqResp.error;
            console.warn('initRqDone: special error!!!! "' + rqResp.error + '"');
        }
        postExtraAlert(rqResp.error, 'border-color: red');
    }

    output.title.textContent = rqResp.title;
    output.fullTitle.textContent = rqResp.title;
    output.author.textContent = rqResp.author;
    output.fullAuthor.textContent = rqResp.author;
    channelName = rqResp.author;
    eid('actions-video-channel-label').dataset.label = rqResp.author;

    output.authorPic.src = imgChoose(rqResp.authorThumbnails,'width',100) || '/img/nouserimage.png';

    subscriptionsUpdateMdata(
        rqResp.authorId,
        rqResp.author,
        imgChoose(rqResp.authorThumbnails,'width',100)
    );
    

    if(rqResp.description.length !== 0) {
        output.description.innerText = rqResp.description;
    } else {
        var ndd = document.createElement('div');
        ndd.classList.add('center');
        ndd.textContent = i18n('video-info-no-description');
        output.description.innerHTML = '';
        output.description.appendChild(ndd);
        ndd = undefined;
    }

    output.data.published.textContent = unixdateformat(rqResp.published);
    output.data.publishedDesc.textContent = unixdateformat(rqResp.published);
    output.data.runtime.textContent = timeformat(rqResp.lengthSeconds);
    output.data.viewcount.textContent = commaSeparateNumber(rqResp.viewCount);
    output.data.viewcountDesc.textContent = commaSeparateNumber(rqResp.viewCount);
    output.data.category.textContent = commaSeparateNumber(rqResp.genre);
    output.data.videoId.textContent = videoId;
    output.data.thumbnail.src = videoThumbnail;

    output.data.rating.like.textContent = commaSeparateNumber(rqResp.likeCount);
    output.data.rating.likePercentBar.textContent = commaSeparateNumber(rqResp.likeCount);
    output.data.rating.dislike.textContent = commaSeparateNumber(rqResp.dislikeCount);
    output.data.rating.dislikePercentBar.textContent = commaSeparateNumber(rqResp.dislikeCount);
        
    var totalVotes = (rqResp.likeCount + rqResp.dislikeCount),
    percents = [
        ((rqResp.likeCount / totalVotes) * 100),
        ((totalVotes / rqResp.viewCount) * 100)
    ];
    
    percents.forEach((e,i,a) => {
        if(isNaN(e)) {
            a[i] = null;
        } else {
            a[i] = a[i].toFixed(2);
        }
    });

    
    output.data.rating.likePercent.textContent = i18n('video-info-like-percent', {percent: percents[0] || '--.--'});
    output.data.rating.votePercent.textContent = i18n('video-info-voters-percent', {percent: percents[1] || '0.00'});
    output.data.rating.likePercentBar.style.width = (percents[0] || '50') + '%';
    if(!rqResp.allowRatings) {
        eid('data-rating').classList.add('hidden');
        eid('data-rating-description-all-container').classList.add('disabledRatings');
    }
    
    if(!rqResp.isFamilyFriendly) {
        postExtraAlert(i18n('video-info-age-restricted'), 'border-color: #ff0');
    }

    if(!rqResp.isListed) {
        eid('unlisted-video-indicator').classList.remove('hidden');
        postExtraAlert(i18n('video-info-unlisted'));
    }

    output.mediaLoaded = [0,0];

    var 
    vidSrc = document.createElement('source');
    
    if(listenMode) {
        eid('minimizeDialogCustomText').textContent = '';

        output.video = document.createElement('audio');

        eid('audioModeDisplay').classList.remove('hidden');
        eid('audioModeDisplay-img').style.backgroundImage = `url(
            ${thumbchoose(rqResp.videoThumbnails, 'medium')}
        )`;
        eid('listen-button').src = '/img/buttons/eye.png';

        document.body.classList.add('audiomode');

        vidSrc.src = chooseMedia('audio', Infinity, rqResp.adaptiveFormats); //infinity is "just choose highest quality"
        output.mediaLoaded[1] = 1;
    } else {
        eid('minimizeDialogCustomText').textContent = i18n('minimize-listen-mode-hint');

        output.video = document.createElement('video');

        //new behavior
        /* output.audio = new Audio();

        output.audio.src = chooseMedia('audio',Infinity);
        vidSrc.src = chooseMedia('video',240);
        output.mediaLoaded[1] = 2; */

        //old behavior
        var allSrc = rqResp.formatStreams;
        for(var i = 0; i < allSrc.length; i++) {
            if(allSrc[i].resolution === '360p') {
                vidSrc.src = allSrc[i].url;
                break;
            }
        }
        output.mediaLoaded[1] = 1;
    }
    output.video.id = 'video';

    //captions
    selectCaption(-1);
    renderCaptionsClear();
    
    captionsMenu.clearMenu();
    captionsMenu.addOption(i18n('disabled'));
    captions.forEach((e) => {

        captionsMenu.addOption(e.label);
    });

    //place recommendeds
    if(!playlistMode) {
        if(rqResp.recommendedVideos.length !== 0) {
            outputRecommends(rqResp.recommendedVideos);
        }
    }

    output.video.appendChild(vidSrc);
    output.videoCont.appendChild(output.video);

    (output.audio || output.video).mozAudioChannelType = 'content';

    //set events
    output.video.onplay = videoEvents.play;
    output.video.onpause = videoEvents.pause;
    output.video.onplaying = videoEvents.playing;
    output.video.onseeking = videoEvents.seeking;
    output.video.onseeked = videoEvents.seeked;
    output.video.onstalled = videoEvents.stalled;
    output.video.onwaiting = videoEvents.waiting;
    output.video.onerror = videoEvents.error;
    output.video.onended = videoEvents.ended;
    output.video.ontimeupdate = videoEvents.timeupdate;
    output.video.oncanplay = videoEvents.canplay;
    output.video.onloadedmetadata = videoEvents.loadedmetadata;

    output.video.querySelector('source:last-child').onerror = videoEvents.srcError;

    output.video.preload = 'metadata';

    videoLoaderShow(true,i18n('video-buffering'));

    if(output.audio) {
        output.audio.oncanplay = videoEvents.canplay; //videoevnet func is same as audio
        output.audio.onloadedmetadata = videoEvents.loadedmetadata; //same as above
    
        output.audio.preload = 'metadata';
    }
    if(curpage === 99) {hideMainMenu();}
    allowBack = false;

    curpage = 0;
    updatenavbar();
    
}

function switchListenMode() {
    var prms = new URLSearchParams(lcHash);
    if(prms.get('listen') === 'true') {
        prms.delete('listen');
    } else {
        prms.set('listen','true');
    }

    prms.delete('t');
    location.hash = prms.toString();
    location.reload();
}