var playlistPage = 1, playlistReady = false, playlistMode = false, playlistItems = [];

function loadPlaylistInit() {
    eid('playlist-indicator').classList.remove('hidden');
    if(playlistId === sessionStorage.getItem('playlistCacheId')) {
        playlistItems = JSON.parse(sessionStorage.getItem('playlistCache'));
        loadPlaylistDone();
    } else {
        playlistReady = false;
        eid('actions-relatedvids-loading-placeholder').classList.remove('hidden');
        loadPlaylist();
    }
}

function loadPlaylist() {
    //videoId and playlistId should be defined
    requestItem(
        'playlists',
        playlistId,
        '?fields=title,videos&page=' + playlistPage,
        loadPlaylistRqDone,
        null,
        true,
        true
    );
    
    console.log('Loading Playlist...!', playlistPage);
}

function loadPlaylistRqDone(rqResp) {
    console.log('loadPlaylistDone');
    playlistItems = playlistItems.concat(rqResp.videos);
    if(rqResp.videos.length === 100 && 0 in rqResp.videos) { //0 in rqResp.videos is a redundant check.
        playlistPage++;
        loadPlaylist();
        return;
    }

    sessionStorage.setItem('playlistCache',JSON.stringify(playlistItems));
    sessionStorage.setItem('playlistCacheId',playlistId);
    sessionStorage.setItem('playlistCacheName',rqResp.title);

    loadPlaylistDone();
}

function loadPlaylistDone(){

    playlistReady = true;

    var count = document.createElement('span'), label = document.createElement('span');
    count.id = 'actions-relatedvids-text-count';

    console.log(playlistItems);

    for(var i = 0; i < playlistItems.length; i++) {
        if(playlistItems[i].videoId === videoId) {
            playlistIndex = i;
            break;
        }
    }

    count.textContent = playlistIndex + 1 + '/' + playlistItems.length;
    label.textContent = sessionStorage.getItem('playlistCacheName');

    eid('actions-relatedvids-text').textContent = ''; //delet
    eid('actions-relatedvids-text').appendChild(count);
    eid('actions-relatedvids-text').appendChild(label);

    outputRecommends(playlistItems);
    playlistItems = [];
}

function playlistNextVideo(force) {
    if(playlistMode && playlistReady) {
        if(force === undefined) {
            force = 0;
        } else {
            force = Number(!force) * 2;
        }
        var rvs = eid('actions-relatedvids').children,
        npi = playlistIndex + (1 - force);
        if(playlistIndexExists(npi)) {
            var nv = rvs[npi];
            showPlaylistChange(npi + 1, rvs.length);
            loadAnotherVideo(nv.dataset.id, npi);
            //init();
        } else {
            if(playlistIndex === rvs.length - 1) {
                videoLoaderShow(true,i18n('video-playlist-ended'));
                playlistEndedNotification();
            }
        }
    }
}

var showPlaylistChangeTO = 0;
function showPlaylistChange(n,t) {
    clearTimeout(showPlaylistChangeTO);
    showPlaylistChangeTO = setTimeout(()=>{
        eid('playlist-change-display').classList.add('hidden');
    },2000);
    eid('playlist-change-display-text').textContent = commaSeparateNumber(n) + '/' + commaSeparateNumber(t);
    eid('playlist-change-display').classList.remove('hidden');
}

function playlistIndexExists(index) {return index in eid('actions-relatedvids').children;}

function playlistEndedNotification() {
    document.removeEventListener('visibilitychange',playlistEndedNotification);
    if(document.visibilityState === 'hidden') {
        document.addEventListener('visibilitychange',playlistEndedNotification);
    } else {
        alertMessage(i18n('video-playlist-ended-toast-message'),10000,1);
    }
}